C-----------------------------------------------------------------------
C
C                        SYRTHES version 3.4
C                        -------------------
C
C     This file is part of the SYRTHES Kernel, element of the
C     thermal code SYRTHES.
C
C     Copyright (C) 1988-2008 EDF S.A., France
C
C     contact: syrthes-support@edf.fr
C
C
C     The SYRTHES Kernel is free software; you can redistribute it
C     and/or modify it under the terms of the GNU General Public License
C     as published by the Free Software Foundation; either version 2 of
C     the License, or (at your option) any later version.
C
C     The SYRTHES Kernel is distributed in the hope that it will be
C     useful, but WITHOUT ANY WARRANTY; without even the implied warranty
C     of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C     GNU General Public License for more details.
C
C
C     You should have received a copy of the GNU General Public License
C     along with the Code_Saturne Kernel; if not, write to the
C     Free Software Foundation, Inc.,
C     51 Franklin St, Fifth Floor,
C     Boston, MA  02110-1301  USA
C
C-----------------------------------------------------------------------
C                    ****************
                     SUBROUTINE ANGOUV
C                    *****************
C
C     ---------------------------------------------------
     *( NDIM,NPOINS,NELEMS,NCOEMA,NDMATS,NODES,NANGLE,DMAT,XMAT)
C     -------------------------------------------------------
C***********************************************************************
C* SYRTHES 3.4.2                                    COPYRIGHT EDF 2008 *
C***********************************************************************
C AUTEURS : C. PENIGUEL, I. RUPP                                       *
C***********************************************************************
C                                                                      *
C      FONCTION :                                                      *
C      ---------     CORRECTION DE LA MATRICE POUR LE CAS DES          *
C                    ELEMENTS AVEC ANGLES OUVERTS                      *
C                    Correction en cours de test mais pas vraiment     *
C                    concluante : il faut un peu raffiner              *
C                                                                      *
C-----------------------------------------------------------------------
C		    (*)    (*)			ARGUMENTS
C   .___________.______._______________________________________________.
C   !    NOM    ! TYPE !MODE!                    ROLE                  !
C   !___________!______!____!__________________________________________!
C   !   DIAG    !  TR  ! M  ! DIAGONALE DE PRECONDITIONNEMENT          !
C   !   WCT     !  TR  ! M  ! TABLEAU  DE TRAVAIL ( NELEMS * NDMATS)   !
C   !___________!______!____!__________________________________________!
C (*) TYPE : E (ENTIER), R (REEL), A (ALPHANUMERIQUE), T (TABLEAU)
C     ET TYPES COMPOSES
C (*) MODE : D (DONNEE NON MODIFIEE), R (RESULTAT), M (DONNEE MODIFIEE)
C            A (TABLEAU AUXILIAIRE)
C-----------------------------------------------------------------------
C    SOUS PROGRAMME(S) APPELE(S)    : ????
C                                     ????
C-----------------------------------------------------------------------
C    SOUS PROGRAMME(S) APPELANT(S)  : ????
C
C***********************************************************************
C
	IMPLICIT NONE
C
C***********************************************************************
C	DONNEES EN COMMON
C***********************************************************************
C
C***********************************************************************
C.. Variables externes
      INTEGER NDIM,NPOINS,NELEMS,NDMATS,NCOEMA
      INTEGER NANGLE(NELEMS),NODES(NELEMS,NDMATS)
C
      DOUBLE PRECISION XMAT(NELEMS,NCOEMA)
      DOUBLE PRECISION DMAT(NPOINS)
C
C.. Variables internes
      INTEGER I,j,N1,N2,N3,N4,N5,N6
C***********************************************************************
C     1- INITIALISATIONS
C     ==================
C
      IF (NDIM.EQ.2) THEN
         DO I=1,NELEMS
c           print*,'angle=',nangle(i),' --> ',(XMAT(i,j),j=1,ncoema)
            N1=NODES(I,1)
            N2=NODES(I,2)
            N3=NODES(I,3)
            N4=NODES(I,4)
            N5=NODES(I,5)
            N6=NODES(I,6)
            IF (NANGLE(I).NE.0) THEN
               IF (XMAT(I,1).GT.0) THEN
                  DMAT(N1)=DMAT(N1)+XMAT(I,1)
                  DMAT(N4)=DMAT(N4)+XMAT(I,1)
                  XMAT(I,1)=0.D0
               ENDIF
               IF (XMAT(I,2).GT.0) THEN
                  DMAT(N1)=DMAT(N1)+XMAT(I,2)
                  DMAT(N6)=DMAT(N6)+XMAT(I,2)
                  XMAT(I,2)=0.D0
               ENDIF
               IF (XMAT(I,3).GT.0) THEN
                  DMAT(N2)=DMAT(N2)+XMAT(I,3)
                  DMAT(N4)=DMAT(N4)+XMAT(I,3)
                  XMAT(I,3)=0.D0
               ENDIF
               IF (XMAT(I,4).GT.0) THEN
                  DMAT(N2)=DMAT(N2)+XMAT(I,4)
                  DMAT(N5)=DMAT(N5)+XMAT(I,4)
                  XMAT(I,4)=0.D0
               ENDIF
               IF (XMAT(I,5).GT.0) THEN
                  DMAT(N3)=DMAT(N3)+XMAT(I,5)
                  DMAT(N5)=DMAT(N5)+XMAT(I,5)
                  XMAT(I,5)=0.D0
               ENDIF
               IF (XMAT(I,6).GT.0) THEN
                  DMAT(N3)=DMAT(N3)+XMAT(I,6)
                  DMAT(N6)=DMAT(N6)+XMAT(I,6)
                  XMAT(I,6)=0.D0
               ENDIF
               IF (XMAT(I,7).GT.0) THEN
                  DMAT(N4)=DMAT(N4)+XMAT(I,7)
                  DMAT(N5)=DMAT(N5)+XMAT(I,7)
                  XMAT(I,7)=0.D0
               ENDIF
               IF (XMAT(I,8).GT.0) THEN
                  DMAT(N4)=DMAT(N4)+XMAT(I,8)
                  DMAT(N6)=DMAT(N6)+XMAT(I,8)
                  XMAT(I,8)=0.D0
               ENDIF
               IF (XMAT(I,9).GT.0) THEN
                  DMAT(N5)=DMAT(N5)+XMAT(I,9)
                  DMAT(N6)=DMAT(N6)+XMAT(I,9)
                  XMAT(I,9)=0.D0
               ENDIF
            ENDIF
         ENDDO
      ELSE
         print*,' Non fait pour l instant - Christophe '
      ENDIF
C     
      END
