C-----------------------------------------------------------------------
C
C                        SYRTHES version 3.4
C                        -------------------
C
C     This file is part of the SYRTHES Kernel, element of the
C     thermal code SYRTHES.
C
C     Copyright (C) 1988-2008 EDF S.A., France
C
C     contact: syrthes-support@edf.fr
C
C
C     The SYRTHES Kernel is free software; you can redistribute it
C     and/or modify it under the terms of the GNU General Public License
C     as published by the Free Software Foundation; either version 2 of
C     the License, or (at your option) any later version.
C
C     The SYRTHES Kernel is distributed in the hope that it will be
C     useful, but WITHOUT ANY WARRANTY; without even the implied warranty
C     of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C     GNU General Public License for more details.
C
C
C     You should have received a copy of the GNU General Public License
C     along with the Code_Saturne Kernel; if not, write to the
C     Free Software Foundation, Inc.,
C     51 Franklin St, Fifth Floor,
C     Boston, MA  02110-1301  USA
C
C-----------------------------------------------------------------------
C                       *****************
                        SUBROUTINE CLOSCT
C                       *****************
C
C***********************************************************************
C* SYRTHES 3.4.2                                    COPYRIGHT EDF 2008 *
C***********************************************************************
C AUTEURS : C. PENIGUEL, I. RUPP                                       *
C***********************************************************************
C
C BUT : CENTRALISATION DES FERMETURES DES FICHIERS DE SYRTHES
C ----       
C-----------------------------------------------------------------------
C                             ARGUMENTS
C .___________.____.____.______________________________________________.
C !    NOM    !TYPE!MODE!                   ROLE                       !
C !___________!____!____!______________________________________________!
C !           !    !    !                                              !
C !___________!____!____!______________________________________________!
C ! COMMONS                                                            !
C !___________!____!____!______________________________________________!
C ! /NLOFCT/  !    ! D  !                                              !
C ! /OPTCT/   !    ! D  !                                              !
C !___________!____!____!______________________________________________!
C
C----------------------------------------------------------------------
C     SOUS PROGRAMME(S) APPELANT  : ???
C-----------------------------------------------------------------------
C     SOUS PROGRAMME(S) APPELE(S) : ---
C-----------------------------------------------------------------------
C
C***********************************************************************
C
      IMPLICIT NONE
C
C***********************************************************************
C     DONNEES EN COMMON  
C***********************************************************************
C
#include "nlofct.h"
#include "fichct.h"
#include "optct.h"
#ifdef MED
#include "med.hf"
#endif
C  
      INTEGER IRET

C***********************************************************************
C
      CLOSE (NFCLCT)
      CLOSE(NFSGCT)
C
      IF (TYPGS.EQ.'SYR') THEN
         CLOSE(NFGGCT)
      ELSE
#ifdef MED
         CALL EFFERM(NFGGCT,IRET)
#endif
      ENDIF

      CLOSE(NFGRCT)
      IF (NCHROS.GE.1) CLOSE(NFGCCT)
      IF (LSUISO) CLOSE(NFGSCT)
      IF (LGEOMF) CLOSE(NFGFCT)
      IF (LRESUF) CLOSE(NFRFCT)
      IF (LCHROF) CLOSE(NFCFCT)
      IF (LHISOL) CLOSE(NFHRCT)
C
C
C----
C FIN
C----
C
      RETURN
      END
