C-----------------------------------------------------------------------
C
C                        SYRTHES version 3.4
C                        -------------------
C
C     This file is part of the SYRTHES Kernel, element of the
C     thermal code SYRTHES.
C
C     Copyright (C) 1988-2008 EDF S.A., France
C
C     contact: syrthes-support@edf.fr
C
C
C     The SYRTHES Kernel is free software; you can redistribute it
C     and/or modify it under the terms of the GNU General Public License
C     as published by the Free Software Foundation; either version 2 of
C     the License, or (at your option) any later version.
C
C     The SYRTHES Kernel is distributed in the hope that it will be
C     useful, but WITHOUT ANY WARRANTY; without even the implied warranty
C     of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C     GNU General Public License for more details.
C
C
C     You should have received a copy of the GNU General Public License
C     along with the Code_Saturne Kernel; if not, write to the
C     Free Software Foundation, Inc.,
C     51 Franklin St, Fifth Floor,
C     Boston, MA  02110-1301  USA
C
C-----------------------------------------------------------------------
C/MEMBR ADD NAME=CMPTNO,SSI=0
                        SUBROUTINE CMPTNO
C                       *****************
C
C     --------------------------------------------------
     *(NREFS,NPOINS,NBCOUS,NBFLUS,NBDIRS,NBECHS,
     * NBRESS,NBRAYS,NBRAIS,NBPRIO,NBMOBS)
C     --------------------------------------------------
C
C***********************************************************************
C* SYRTHES 3.4.2                                    COPYRIGHT EDF 2008 *
C***********************************************************************
C AUTEURS : C. PENIGUEL, I. RUPP                                       *
C***********************************************************************
C FONCTION :                                                           *
C ----------                                                           *
C             COMPTE DES NOEUDS PORTANT LES DIVERSES CONDITIONS        *
C             POSSIBLES                                                *
C             (Necessaire pour les dimensionnements de tableaux)       *
C                                                                      *
C-----------------------------------------------------------------------
C                             ARGUMENTS
C .___________.____.____.______________________________________________.
C !    NOM    !TYPE!MODE!                   ROLE                       !
C !___________!____!____!______________________________________________!
C !  NREFS    ! TE ! D  ! REFERENCES DES NOEUDS SOLIDES                !
C !  NPOINS   !  E ! D  ! NOMBRE DE NOEUDS DU MAILLAGE SOLIDE          !
C !  NBCOUS   !  E ! R  ! NOMBRE DE NOEUDS SOLIDES COUPLES             !
C !  NBFLUS   !  E ! R  ! NOMBRE DE NOEUDS SOLIDES AVEC CL DE TYPE FLUX!
C !  NBDIRS   !  E ! R  ! NOMBRE DE NOEUDS SOLIDES AVEC CL DIRICHLET   !
C !  NBECHS   !  E ! R  ! NOMBRE DE NOEUDS SOLIDES AVEC CL COEF ECH    !
C !  NBRESS   !  E ! R  ! NOMBRE DE NOEUDS SOLIDES AVEC CL RESI CONTACT!
C !  NBRAYS   !  E ! R  ! NOMBRE DE NOEUDS SOLIDES AVEC RAYONNEMENT    !
C !  NBRAIS   !  E ! R  ! NOMBRE DE NOEUDS SOLIDES AVEC RAYONNEMENT INF!
C !  NBPRIO   !  E ! R  ! NOMBRE DE NOEUDS SOLIDES PERIODIQUES         !
C !  NBMOBS   !  E ! R  ! NOMBRE DE NOEUDS SOLIDES EN MOUVEMENT        !
C !___________!____!____!______________________________________________!
C ! COMMONS                                                            !
C !____________________________________________________________________!
C ! /XREFER/  !    ! D  !                                              !
C ! /NLOFES/  !    ! D  !                                              !
C !___________!____!____!______________________________________________!
C
C (*) TYPE : E (ENTIER), R (REEL), A (ALPHANUMERIQUE), T (TABLEAU)
C     ET TYPES COMPOSES
C (*) MODE : D (DONNEE NON MODIFIEE), R (RESULTAT), M (DONNEE MODIFIEE)
C            A (TABLEAU AUXILIAIRE)
C-----------------------------------------------------------------------
C     SOUS PROGRAMME(S) APPELE(S) :
C
C-----------------------------------------------------------------------
C     SOUS PROGRAMME(S) APPELANT(S) :
C
C***********************************************************************
C
      IMPLICIT NONE
C
C***********************************************************************
C     DONNEES EN COMMON  
C **********************************************************************
C
#include "xrefer.h"
C
C***********************************************************************
C 
C.. Variables externes
      INTEGER NPOINS,NREFS(NPOINS)
      INTEGER NBCOUS,NBFLUS,NBDIRS,NBECHS,NBRESS,NBRAYS,NBRAIS
      INTEGER NBPRIO,NBMOBS
C
C.. Variables internes
      INTEGER I,NUMREF,N1
C
C***********************************************************************
C
C     1- INITIALISATIONS
C     ------------------
C
      NBCOUS = 0
      NBFLUS = 0
      NBDIRS = 0
      NBECHS = 0
      NBRESS = 0
      NBRAYS = 0
      NBRAIS = 0
      NBPRIO = 0
      NBMOBS = 0
C
C
      DO 100 I=1,NPOINS
C
        NUMREF = NREFS(I)
C
        IF (NUMREF.NE.0) THEN
C
          DO 105 N1=1,NRFMAX
C
            IF (IREFSC(N1).NE.0 .AND. NUMREF.EQ.N1) THEN
                NBCOUS = NBCOUS + 1
            ENDIF
C
            IF (IREFSF(N1).NE.0 .AND. NUMREF.EQ.N1) THEN
                NBFLUS = NBFLUS + 1
            ENDIF
C            
            IF (IREFSD(N1).NE.0 .AND. NUMREF.EQ.N1) THEN
                NBDIRS = NBDIRS + 1
            ENDIF
C
            IF (IREFSE(N1).NE.0 .AND. NUMREF.EQ.N1) THEN
                NBECHS = NBECHS + 1
            ENDIF
C
            IF (IREFRE(N1).NE.0 .AND. NUMREF.EQ.N1) THEN
                NBRESS = NBRESS + 1
            ENDIF
C
            IF (IREFRA(N1).NE.0 .AND. NUMREF.EQ.N1) THEN
                NBRAYS = NBRAYS + 1
            ENDIF
C
            IF (IREFRI(N1).NE.0 .AND. NUMREF.EQ.N1) THEN
                NBRAIS = NBRAIS + 1
            ENDIF
C
            IF (IREFPR(N1).NE.0 .AND. NUMREF.EQ.N1) THEN
                NBPRIO = NBPRIO + 1
            ENDIF
C
            IF (IREFMO(N1).NE.0 .AND. NUMREF.EQ.N1) THEN
                NBMOBS = NBMOBS + 1
            ENDIF
C
  105     CONTINUE
C
        ENDIF
C
  100 CONTINUE
C
C
      END
