C-----------------------------------------------------------------------
C
C                        SYRTHES version 3.4
C                        -------------------
C
C     This file is part of the SYRTHES Kernel, element of the
C     thermal code SYRTHES.
C
C     Copyright (C) 1988-2008 EDF S.A., France
C
C     contact: syrthes-support@edf.fr
C
C
C     The SYRTHES Kernel is free software; you can redistribute it
C     and/or modify it under the terms of the GNU General Public License
C     as published by the Free Software Foundation; either version 2 of
C     the License, or (at your option) any later version.
C
C     The SYRTHES Kernel is distributed in the hope that it will be
C     useful, but WITHOUT ANY WARRANTY; without even the implied warranty
C     of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C     GNU General Public License for more details.
C
C
C     You should have received a copy of the GNU General Public License
C     along with the Code_Saturne Kernel; if not, write to the
C     Free Software Foundation, Inc.,
C     51 Franklin St, Fifth Floor,
C     Boston, MA  02110-1301  USA
C
C-----------------------------------------------------------------------
C/MEMBR ADD NAME=SECIDE,SSI=0
                        SUBROUTINE SECIDE
C                       *****************
C
C     --------------
     *(NFIC,NUMSEC)
C     --------------
C
C***********************************************************************
C* SYRTHES 3.4.2                                    COPYRIGHT EDF 2008 *
C***********************************************************************
C AUTEURS : C. PENIGUEL, I. RUPP                                       *
C***********************************************************************
C FONCTION :                                                           *
C ----------                                                           *
C             POSITIONNEMENT SUR UNE SECTION DONNEE DU FICHIER IDEAS   *
C                                                                      *
C-----------------------------------------------------------------------
C                             ARGUMENTS
C .___________.____.____.______________________________________________.
C !    NOM    !TYPE!MODE!                   ROLE                       !
C !___________!____!____!______________________________________________!
C !  NFIC     !  E ! D  ! NUMERO LOGIQUE DU FICHIER                    !
C !  NUMSEC   !  E ! D  ! NUMERO DE LA SECTION RECHERCHEE              !
C !___________!____!____!______________________________________________!
C ! COMMONS                                                            !
C !____________________________________________________________________!
C ! /NLOFCT/  !    ! D  !                                              !
C ! /NLOFES/  !    ! D  !                                              !
C !___________!____!____!______________________________________________!
C
C (*) TYPE : E (ENTIER), R (REEL), A (ALPHANUMERIQUE), T (TABLEAU)
C     ET TYPES COMPOSES
C (*) MODE : D (DONNEE NON MODIFIEE), R (RESULTAT), M (DONNEE MODIFIEE)
C            A (TABLEAU AUXILIAIRE)
C-----------------------------------------------------------------------
C     SOUS PROGRAMME(S) APPELE(S) :
C
C-----------------------------------------------------------------------
C     SOUS PROGRAMME(S) APPELANT(S) :
C
C***********************************************************************
C
      IMPLICIT NONE
C
C***********************************************************************
C     DONNEES EN COMMON  
C **********************************************************************
C
#include "nlofes.h"
C
C***********************************************************************
C 
C.. Variables externes
      INTEGER NUMSEC,NFIC
C
C.. Variables internes
      INTEGER N
      CHARACTER*6 CH
C
C***********************************************************************
C
C
C     0- INITIALISATIONS
C     ==================
C
      REWIND (NFIC)
C
C     1- PARCOURS DU FICHIER
C     ======================
C
   10 READ(NFIC,1000,ERR=99,END=99) CH
      IF (CH .NE. '    -1') GOTO 10
C
   20 READ(NFIC,*,ERR=99,END=99) N
      IF(N.EQ.-1) THEN
         GOTO 20
      ELSEIF (N .NE. NUMSEC) THEN
         GOTO 10
      ENDIF
C
      RETURN
C
C     2- ERREURS
C     ==========
C
   99 CONTINUE
      WRITE(NFECRA,2000) NUMSEC
      STOP
C
C
C--------
C FORMATS
C--------
C 
 1000 FORMAT(A6)
 2000 FORMAT('  %% ERREUR SECIDE : LE FICHIER IDEAS EST INCORRET',/,
     &      21X,'LA SECTION ',I6,' EST INTROUVABLE ')
C 
C
      END
